diff --git a/gdb/breakpoint.c b/gdb/breakpoint.c
index 908a1ea..775d555 100644
--- a/gdb/breakpoint.c
+++ b/gdb/breakpoint.c
@@ -14790,7 +14790,7 @@ map_breakpoint_numbers (char *args, void (*function) (struct breakpoint *,
 
   while (!state.finished)
     {
-      char *p = state.string;
+      const char *p = state.string;
 
       match = 0;
 
diff --git a/gdb/cli/cli-utils.c b/gdb/cli/cli-utils.c
index a0ebc11..819c94c 100644
--- a/gdb/cli/cli-utils.c
+++ b/gdb/cli/cli-utils.c
@@ -35,10 +35,10 @@
    commonly this is `-'.  If you don't want a trailer, use \0.  */
 
 static int
-get_number_trailer (char **pp, int trailer)
+get_number_trailer (const char **pp, int trailer)
 {
   int retval = 0;	/* default */
-  char *p = *pp;
+  const char *p = *pp;
 
   if (*p == '$')
     {
@@ -59,7 +59,7 @@ get_number_trailer (char **pp, int trailer)
 	  /* Internal variable.  Make a copy of the name, so we can
 	     null-terminate it to pass to lookup_internalvar().  */
 	  char *varname;
-	  char *start = ++p;
+	  const char *start = ++p;
 	  LONGEST val;
 
 	  while (isalnum (*p) || *p == '_')
@@ -102,7 +102,7 @@ get_number_trailer (char **pp, int trailer)
 	++p;
       retval = 0;
     }
-  p = skip_spaces (p);
+  p = skip_spaces_const (p);
   *pp = p;
   return retval;
 }
@@ -110,16 +110,29 @@ get_number_trailer (char **pp, int trailer)
 /* See documentation in cli-utils.h.  */
 
 int
-get_number (char **pp)
+get_number_const (const char **pp)
 {
   return get_number_trailer (pp, '\0');
 }
 
 /* See documentation in cli-utils.h.  */
 
+int
+get_number (char **pp)
+{
+  int result;
+  const char *p = *pp;
+
+  result = get_number_trailer (&p, '\0');
+  *pp = (char *) p;
+  return result;
+}
+
+/* See documentation in cli-utils.h.  */
+
 void
 init_number_or_range (struct get_number_or_range_state *state,
-		      char *string)
+		      const char *string)
 {
   memset (state, 0, sizeof (*state));
   state->string = string;
@@ -137,15 +150,15 @@ get_number_or_range (struct get_number_or_range_state *state)
       state->last_retval = get_number_trailer (&state->string, '-');
       if (*state->string == '-')
 	{
-	  char **temp;
+	  const char **temp;
 
 	  /* This is the start of a range (<number1> - <number2>).
 	     Skip the '-', parse and remember the second number,
 	     and also remember the end of the final token.  */
 
 	  temp = &state->end_ptr; 
-	  state->end_ptr = skip_spaces (state->string + 1);
-	  state->end_value = get_number (temp);
+	  state->end_ptr = skip_spaces_const (state->string + 1);
+	  state->end_value = get_number_const (temp);
 	  if (state->end_value < state->last_retval) 
 	    {
 	      error (_("inverted range"));
@@ -191,7 +204,7 @@ get_number_or_range (struct get_number_or_range_state *state)
    no arguments.  */
 
 int
-number_is_in_list (char *list, int number)
+number_is_in_list (const char *list, int number)
 {
   struct get_number_or_range_state state;
 
diff --git a/gdb/cli/cli-utils.h b/gdb/cli/cli-utils.h
index fed876b..1f0f3df 100644
--- a/gdb/cli/cli-utils.h
+++ b/gdb/cli/cli-utils.h
@@ -26,6 +26,10 @@
    Currently the string can either be a number,  or "$" followed by the
    name of a convenience variable, or ("$" or "$$") followed by digits.  */
 
+extern int get_number_const (const char **);
+
+/* Like get_number_const, but takes a non-const "char **".  */
+
 extern int get_number (char **);
 
 /* An object of this type is passed to get_number_or_range.  It must
@@ -40,7 +44,7 @@ struct get_number_or_range_state
 
   /* The string being parsed.  When parsing has finished, this points
      past the last parsed token.  */
-  char *string;
+  const char *string;
 
   /* Last value returned.  */
   int last_retval;
@@ -50,7 +54,7 @@ struct get_number_or_range_state
 
   /* When parsing a range, a pointer past the final token in the
      range.  */
-  char *end_ptr;
+  const char *end_ptr;
 
   /* Non-zero when parsing a range.  */
   int in_range;
@@ -60,7 +64,7 @@ struct get_number_or_range_state
    get_number_or_range_state.  STRING is the string to be parsed.  */
 
 extern void init_number_or_range (struct get_number_or_range_state *state,
-				  char *string);
+				  const char *string);
 
 /* Parse a number or a range.
    A number will be of the form handled by get_number.
@@ -87,7 +91,7 @@ extern int get_number_or_range (struct get_number_or_range_state *state);
    be interpreted as typing a command such as "delete break" with 
    no arguments.  */
 
-extern int number_is_in_list (char *list, int number);
+extern int number_is_in_list (const char *list, int number);
 
 /* Skip leading whitespace characters in INP, returning an updated
    pointer.  If INP is NULL, return NULL.  */
diff --git a/gdb/printcmd.c b/gdb/printcmd.c
index 228d4ad..b4fd894 100644
--- a/gdb/printcmd.c
+++ b/gdb/printcmd.c
@@ -1618,7 +1618,7 @@ map_display_numbers (char *args,
 
   while (!state.finished)
     {
-      char *p = state.string;
+      const char *p = state.string;
 
       num = get_number_or_range (&state);
       if (num == 0)
diff --git a/gdb/value.c b/gdb/value.c
index 29abe5f..5666aa3 100644
--- a/gdb/value.c
+++ b/gdb/value.c
@@ -3446,7 +3446,7 @@ value_from_decfloat (struct type *type, const gdb_byte *dec)
    for details.  */
 
 struct value *
-value_from_history_ref (char *h, char **endp)
+value_from_history_ref (const char *h, const char **endp)
 {
   int index, len;
 
@@ -3477,7 +3477,12 @@ value_from_history_ref (char *h, char **endp)
 	  *endp += len;
 	}
       else
-	index = -strtol (&h[2], endp, 10);
+	{
+	  char *local_end;
+
+	  index = -strtol (&h[2], &local_end, 10);
+	  *endp = local_end;
+	}
     }
   else
     {
@@ -3488,7 +3493,12 @@ value_from_history_ref (char *h, char **endp)
 	  *endp += len;
 	}
       else
-	index = strtol (&h[1], endp, 10);
+	{
+	  char *local_end;
+
+	  index = strtol (&h[1], &local_end, 10);
+	  *endp = local_end;
+	}
     }
 
   return access_value_history (index);
diff --git a/gdb/value.h b/gdb/value.h
index 86ebd70..4654042 100644
--- a/gdb/value.h
+++ b/gdb/value.h
@@ -569,7 +569,7 @@ extern struct value *value_from_pointer (struct type *type, CORE_ADDR addr);
 extern struct value *value_from_double (struct type *type, DOUBLEST num);
 extern struct value *value_from_decfloat (struct type *type,
 					  const gdb_byte *decbytes);
-extern struct value *value_from_history_ref (char *, char **);
+extern struct value *value_from_history_ref (const char *, const char **);
 
 extern struct value *value_at (struct type *type, CORE_ADDR addr);
 extern struct value *value_at_lazy (struct type *type, CORE_ADDR addr);